// Definition of the ClientSocket class

#ifndef ClientSocketData_class
#define ClientSocketData_class

#include "ClientSocket.h"
#include "SocketException.h"
#include "poruka.h"
#include <vector>
#include <iostream>

class ClientSocketData : public ClientSocket{
	std::string buffer;
public:
	
	ClientSocketData (const std::string&, int port )/*:throw SocketException*/;
//  virtual ~ClientSocket(){};
	friend const ClientSocketData& operator<<(const ClientSocketData& dat,const string &);
	friend ClientSocketData& operator>>(ClientSocketData& dat,string &);
	
	friend const ClientSocketData& operator<<(const ClientSocketData& dat,unsigned);
	friend ClientSocketData& operator>>(ClientSocketData& dat,unsigned&);
	
	friend const ClientSocketData& operator<<(const ClientSocketData& dat,bool);
	friend ClientSocketData& operator>>(ClientSocketData& dat,bool&);

	friend const ClientSocketData& operator<<(const ClientSocketData& dat,const Poruka &);
	friend ClientSocketData& operator>>(ClientSocketData& dat,Poruka&);

/*
//	template<typename T>
	friend const ClientSocketData& operator<<(const ClientSocketData& dat,const vector<string>&);
	//template<typename T>
	friend ClientSocketData& operator>>(ClientSocketData& dat,vector<string>&);
	
	friend const ClientSocketData& operator<<(const ClientSocketData& dat,const vector<unsigned>&);
	friend ClientSocketData& operator>>(ClientSocketData& dat,vector<unsigned>&);
*/
	template<typename T>
	friend const ClientSocketData& operator<<(const ClientSocketData& dat,const vector<T>& vekt);
	
	template<typename T>
	friend ClientSocketData& operator>>(ClientSocketData& dat,vector<T>& vekt);
};

template<typename T>
const ClientSocketData& operator<<(ClientSocketData& dat,const vector<T>& vekt){
	unsigned duz=vekt.size();
	dat<<duz;
	for(int i=0;i<duz;i++)
		dat<<vekt[i];
	return dat;
}

template<typename T>
ClientSocketData& operator>>(ClientSocketData& dat,vector<T>& vekt){
	unsigned duz;
	dat>>duz;
	vekt.clear();
	vekt.reserve(duz);
	for(int i=0;i<duz;i++){
		T s;
		dat>>s;
		vekt.push_back(s);
	}
	return dat;
}

#endif
