#include "./hederi/meni.h"

Meni::Meni(string nasl,char kom,Meni_dugme *kkraj,unsigned short duz):
	Meni_stavka(nasl,kom),kraj(kkraj){
		meni.reserve(duz);
		naslov=nasl;
}
Meni::~Meni(){
	for (vector<Meni_stavka*>::iterator i=meni.begin();i!=meni.end();i++)
		delete *i;
}

bool Meni::izvrsi_komanda(char c)const{
	for (vector<Meni_stavka*>::const_iterator i=meni.begin();i!=meni.end();i++)
		if ((*i)->komanda()==c){
			(*i)->radi();
			return true;
		}
	return false;
}

Meni* Meni::set_kraj(Meni_dugme* kkraj){
	kraj=kkraj;
	return this;
}

Meni* Meni::dodaj(Meni_stavka *m){
	m->set_predak(this);
	meni.push_back(m);
	return this;
}
string Meni::toString()const{
	return string("[")+komanda()+"] + "+uzmi_opis();
}

ostream& operator<<(ostream& dat,const Meni& m){
	dat<<endl<<'['<<m.adresa()<<']'<<m.naslov<<':'<<endl;
	for (vector<Meni_stavka*>::const_iterator i=m.meni.begin();i!=m.meni.end();i++)
		dat<<(*i)->toString()<<endl;
	dat<<'['<<(m.kraj)->komanda()<<']'<<" <- "<<(m.kraj)->uzmi_opis()<<endl;
	dat<<"Komanda: ";
	return dat;
}

void Meni::radi(){
	while(true){
		cout<<*this;
		char c; cin>>c;
		if (kraj->komanda()==c){
			kraj->radi();
			break;
		}    
		if (!izvrsi_komanda(c)) cout<<"Neispravna komanda\n";
	}
}
