// Implementation of the ServerSocket class

#include "./hederi/ServerSocketData.h"
#include "./hederi/konverzije.h"
#include <string>
#include <iostream>
#include <vector>
using namespace std;


ServerSocketData::ServerSocketData (int port ):ServerSocket(port){}
ServerSocketData::ServerSocketData (){}

const ServerSocketData& operator<<(const ServerSocketData& dat,const string &s){
	string st("$");
	st+=s;
	st.append("$\n");
//	cout<<"send: "<<st;
	((ServerSocket&)dat).operator<<(st);
	return dat;
}

ServerSocketData& operator>>(ServerSocketData& dat,string& s){
	string &buffer=dat.buffer;
	string st;
	while(true){
		if (buffer.empty())
			((ServerSocket&)dat).operator>>(buffer);
		unsigned k1=buffer.find('$');
		if (k1==-1) {
			buffer.clear();
			continue;
		}
		unsigned k2=buffer.find('$',k1+1);
		if (k2==-1) {
			st+=buffer.substr(k1);
			buffer.clear();
			break;
		}
		st+=buffer.substr(k1+1,k2-k1-1);
		buffer=buffer.substr(k2+1);
//		cout<<"receive: "<<st<<endl;
		if (buffer.empty()) cout<<"---------------\n";
		s=st;
		return dat;
	}
	while(true){
		if (buffer.empty())
			((ServerSocket&)dat).operator>>(buffer);
		unsigned k=buffer.find('$');
		if (k==-1) {
			st+=buffer.substr(0);
			buffer.clear();
			continue;
		}
		st+=buffer.substr(0,k-1);
		buffer=buffer.substr(k+1);
//		cout<<"receive: "<<st<<endl;
		if (buffer.empty()) cout<<"---------------\n";
		s=st;
		return dat;
	}
}

const ServerSocketData& operator<<(const ServerSocketData& dat,unsigned i){
	dat<<unsignToString(i);
	return dat;
}
ServerSocketData& operator>>(ServerSocketData& dat,unsigned& i){
	std::string s;
	dat>>s;
	try{
		i=stringToUnsigned(s);
	}catch(Greska g){
		throw SocketException("ocekivano unsigned");
	}
	return dat;
}
const ServerSocketData& operator<<(const ServerSocketData& dat,bool b){
	dat<<boolToStr(b);
	return dat;
}
ServerSocketData& operator>>(ServerSocketData& dat,bool& b){
	std::string s;
	dat>>s;
	try{
		b=strToBool(s);
	}catch(Greska g){
		throw SocketException("ocekivano bool");
	}
	return dat;
}
const ServerSocketData& operator<<(const ServerSocketData& dat,const Poruka &por){
	dat<<por.toString();
	return dat;
}

ServerSocketData& operator>>(ServerSocketData& dat,Poruka& por){
	string s;
	dat>>s;
	por=Poruka::toPoruka(s);
	return dat;
}

/*
const ServerSocketData& operator<<(const ServerSocketData& dat,const vector<string>& vekt){
	unsigned duz=vekt.size();
	dat<<duz;
	for(int i=0;i<duz;i++)
		dat<<vekt[i];
	return dat;
}

ServerSocketData& operator>>(ServerSocketData& dat,vector<string>& vekt){
	unsigned duz;
	dat>>duz;
	vekt.clear();
	vekt.reserve(duz);
	for(int i=0;i<duz;i++){
		string s;
		dat>>s;
		vekt.push_back(s);
	}
	return dat;
}

const ServerSocketData& operator<<(const ServerSocketData& dat,const vector<unsigned>& vekt){
	unsigned duz=vekt.size();
	dat<<duz;
	for(int i=0;i<duz;i++)
		dat<<vekt[i];
	return dat;
}

ServerSocketData& operator>>(ServerSocketData& dat,vector<unsigned>& vekt){
	unsigned duz;
	dat>>duz;
	vekt.clear();
	vekt.reserve(duz);
	for(int i=0;i<duz;i++){
		unsigned s;
		dat>>s;
		vekt.push_back(s);
	}
	return dat;
}
*/
