// Definition of the ServerSocket class

#ifndef ServerSocketData_class
#define ServerSocketData_class

#include "ServerSocket.h"
#include "SocketException.h"
#include "poruka.h"
#include <vector>
#include <iostream>

class ServerSocketData : public ServerSocket{
	std::string buffer;
public:
	
	ServerSocketData (int port );
	ServerSocketData ();
	friend const ServerSocketData& operator<<(const ServerSocketData& dat,const string &);
	friend ServerSocketData& operator>>(ServerSocketData& dat,string &);
	
	friend const ServerSocketData& operator<<(const ServerSocketData& dat,unsigned);
	friend ServerSocketData& operator>>(ServerSocketData& dat,unsigned&);
	
	friend const ServerSocketData& operator<<(const ServerSocketData& dat,bool);
	friend ServerSocketData& operator>>(ServerSocketData& dat,bool&);

	friend const ServerSocketData& operator<<(const ServerSocketData& dat,const Poruka &);
	friend ServerSocketData& operator>>(ServerSocketData& dat,Poruka&);

	template<typename T>
	friend const ServerSocketData& operator<<(const ServerSocketData& dat,const vector<T>& vekt);
	
	template<typename T>
	friend ServerSocketData& operator>>(ServerSocketData& dat,vector<T>& vekt);
};

template<typename T>
const ServerSocketData& operator<<(const ServerSocketData& dat,const vector<T>& vekt){
	unsigned duz=vekt.size();
	dat<<duz;
	for(int i=0;i<duz;i++)
		dat<<vekt[i];
	return dat;
}

template<typename T>
ServerSocketData& operator>>(ServerSocketData& dat,vector<T>& vekt){
	unsigned duz;
	dat>>duz;
	vekt.clear();
	vekt.reserve(duz);
	for(int i=0;i<duz;i++){
		T s;
		dat>>s;
		vekt.push_back(s);
	}
	return dat;
}

#endif
