#include "./hederi/izvestac_poruke.h"
#include "./hederi/konverzije.h"


Izvestac_poruke::Izvestac_poruke(ServerSocketData&s,const string& nasl):sock(s),mutex(1),naslov(nasl){}

void Izvestac_poruke::novi_pratilac(Pratilac_poruke* p){
	mutex.wait();
	pratioci.push_back(p);
	p->stare_poruke(poruke);
	mutex.signal();
}

/* asctime example */
/*
#include <stdio.h>
#include <time.h>

int main ()
{
  time_t rawtime;
  struct tm * timeinfo;

  time ( &rawtime );
  timeinfo = localtime ( &rawtime );
  printf ( "Current date and time are: %s", asctime (timeinfo) );
  
  return 0;
}

*/
/* ctime example */
#include <time.h>

static string vreme(){
  time_t rawtime;

  time ( &rawtime );
  struct tm * timeinfo = localtime ( &rawtime );
/*
  int hour=timeinfo->tm_hour;
  int min=timeinfo->tm_min;
  int sek=timeinfo->tm_sec;
  int year=timeinfo->tm_sec;
  int month=timeinfo->tm_sec;
  int day=timeinfo->tm_sec;
  string vreme=unsignToString(hour)+":"+unsignToString(min)+":"+unsignToString(sek);
//  string datum=unsignToString(day)+"."+unsignToString(month)+"."+unsignToString(year);
  return vreme;//*+"  "+datum;
*/
  string st=ctime (&rawtime);
  st.replace(st.size()-1,1,"");
  return st;
  
  return 0;
}


void Izvestac_poruke::nova_poruka(string s){
//	string n=naslov+" ("+vreme()+")";
	string n="izvestac - "+naslov+"\nvreme - ("+vreme()+")";
	Poruka p(n,s);
	mutex.wait();
//	int duz=pratioci.size();
//	for(int i=0;i<duz;i++)
	poruke.push_back(p);
	for(vector<Pratilac_poruke*>::const_iterator i=pratioci.begin();i!=pratioci.end();i++)
		if (*i) (*i)->nova_poruka(p);
	mutex.signal();
}

const string& Izvestac_poruke::uzmi_naslov() const{
	return naslov;
}

void Izvestac_poruke::prenos(){
	string s;
	do{
		try{
			sock>>s;
		}catch(SocketException e){
			cout<<"izvestac vise ne izvestava\n";
/*			
			mutex.wait();
			mutex.signal();
*/			
			nova_poruka(string("greska u komunikaciji"));
/*			
			mutex.wait();
			poruke.push_back(str_kraj);
			mutex.signal();
*/
			nova_poruka(str_kraj);
			break;
		}
//		poruke.push_back(s);
		nova_poruka(s);
	}while(s!=str_kraj);
//	cout<<"kraj prenosa je detoktovan\n";
}
ostream& operator<<(ostream& dat,const Izvestac_poruke& izv){
	dat<<"izvestac: "<<izv.naslov<<endl;
	dat<<izv.poruke<<endl;
	return dat;
}
ofstream& operator<<(ofstream& dat,const Izvestac_poruke& izv){
	dat<<"izvestac: "<<izv.naslov<<endl;
	dat<<izv.poruke<<endl;
/*
	for(vector<string>::const_iterator i=izv.poruke.begin();i!=izv.poruke.end();i++)
		dat<<(*i)<<endl;
*/
	return dat;
}
	
